SystemOrganization addCategory: #'Daliot-FileSync'!
SystemOrganization addCategory: #'Daliot-common'!

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:20'!
multiDimensionalCollect: monoBlock 

	|stream|
	stream := self species writeStream.
	self multiDimensionalDo: [:sample| stream nextPut: (monoBlock value: sample) ].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:37'!
multiDimensionalDo: monoBlock

	self isEmpty ifTrue: [^self].
	self size = 1 ifTrue: [^self first do: [:oneParam| monoBlock value: (Array with: oneParam)]].
	self first do: [:first| 
		(self copyFrom: 2 to: self size) multiDimensionalDo: [:paramWithoutFirst|
			monoBlock value: (Array with: first) , paramWithoutFirst
		]]! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:43'!
collection

	^collection! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/23/2008 20:15'!
equals: aNumber

	"Ported from Dolphin 4.0 by Howard J. Oh"
	| max significantDifference |
	significantDifference := 1.0e-9.
	^(max := self abs max: aNumber abs) <= significantDifference
		or: [(self-aNumber) abs < (significantDifference * max)]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:42'!
quoAndRem: aNumber

	^{self quo: aNumber . self rem: aNumber}! !

!PasteUpMorph methodsFor: '*Daliot' stamp: 'hjo 3/25/2008 18:05'!
collapseAllSystemWindows

	(self submorphs select: [:so| so class = SystemWindow ]) do: [: ow | ow collapse ]! !

!String class methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:58'!
fromLines: anArray

	^self streamContents: [:stream |

		anArray 
			do: [:each| stream nextPutAll: each ]
			separatedBy: [ "Dolphin 4: stream nextPutAll: self lineDelimiter" stream cr ].

	]! !

!String methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:57'!
lines

	^self subStrings: '
'! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:17'!
ascendingSortBlock

	^[:objectA :objectB | (objectA perform: self) < (objectB perform: self) ]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:22'!
descendingSortBlock

	^[:objectA :objectB | (objectA perform: self) > (objectB perform: self) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:14'!
ascendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) < (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:21'!
descendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) > (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/18/2008 21:21'!
whileFalse: aBlockContext loopLimit: anInteger 

	|loopCount|
	loopCount := 0.
	self whileFalse: [aBlockContext value. loopCount := loopCount + 1. loopCount > anInteger ifTrue: [self error: 'Infinite loop suspected.' ] ]! !

TestCase subclass: #FileSyncSideTest
	instanceVariableNames: 'o'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSideTest methodsFor: 'private' stamp: 'hjo 1/1/2008 23:20'!
answerForFullPathTest

	^'ab' , FileDirectory slash , 'cd'! !

!FileSyncSideTest methodsFor: 'running' stamp: 'hjo 1/1/2008 23:16'!
setUp

	super setUp.
	o := FileSyncSide new.
! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/5/2008 01:19'!
testIsFolder

	o path: 'root'.
	o itemName: 'folder'.
	self assert: (o isFolderContext: nil)! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:20'!
testSyncSide

	o path: 'ab'.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:21'!
testSyncSide2

	o path: 'ab'.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:29'!
testSyncSide3

	o path: 'ab' , FileDirectory slash.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:43'!
testSyncSide4

	o path: 'ab' , FileDirectory slash.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

TestCase subclass: #FileSyncTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:46'!
testDestinationSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs destinationSide fullPath = ('des' , FileDirectory slash , 'ff').
	! !

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:09'!
testReferenceSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs referenceSide fullPath = ('refe' , FileDirectory slash , 'ff').
	! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:08'!
assertEquals: expected to: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

Object subclass: #FileSync
	instanceVariableNames: 'referencePath fileName destinationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSync classSide methodsFor: 'instance creation' stamp: 'hjo 1/1/2008 03:35'!
from: aByteString to: aByteString2 for: aByteString3 

	^self new
		referencePath: aByteString;
		destinationPath:aByteString2;
		fileName:aByteString3;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:26'!
destinationFile
	^FileDirectory on: destinationPath , FileDirectory slash , fileName! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:36'!
destinationPath: aByteString 
	destinationPath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:48'!
destinationSide
	
	^FileSyncSide new
		path: destinationPath;
		itemName: fileName;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:37'!
fileName: aByteString 
	fileName :=aByteString! !

!FileSync methodsFor: 'creation' stamp: 'hjo 1/1/2008 02:20'!
init
	referencePath := 'refe'.
	destinationPath := 'des'.
	fileName := 'ff'! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:35'!
referencePath: aByteString 
	referencePath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:11'!
referenceSide
	
	^FileSyncSide new
		path: referencePath;
		itemName: fileName;
		yourself! !

Object subclass: #FileSyncSide
	instanceVariableNames: 'path itemName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:42'!
fullPath

	^(path endsWithThese: FileDirectory slash)
		ifTrue: [self fullPathIfPathLastIsSlash]
		ifFalse: [self fullPathIfPathLastIsNotSlash]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:35'!
fullPathIfPathLastIsNotSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [path , itemName]
		ifFalse: [path , FileDirectory slash , itemName]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:37'!
fullPathIfPathLastIsSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [ path , itemName copyWithoutFirst ]
		ifFalse: [ path , itemName ]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:04'!
itemName: aString

	itemName :=aString! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:03'!
path: aString

	path := aString! !

Object subclass: #IDontKnow
	instanceVariableNames: 's d stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:27'!
encodeMacDirectory: aFileDirectory

	^String streamContents: [:ssss | 
		self encodeMacDirectory: aFileDirectory on: ssss ]! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:37'!
encodeMacDirectory: aFileDirectory on: pathStream

	aFileDirectory fullName = FileDirectory root fullName
		ifFalse: [ self encodeMacDirectory: aFileDirectory on: pathStream containingDirectory ].
		
	pathStream nextPutAll: FileDirectory slash.
	pathStream nextPutAll: (self encodeMacFileName: aFileDirectory fullName)! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:35'!
encodeMacFileName: aString

	^String streamContents:
		[:encoded|
			aString
				do: [:char| 
					self assert: [(':' includes: char) not].
					('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-^{},+' includes: char) 
					ifTrue: [encoded nextPut: char ] 
					ifFalse: [
						char = $/ ifTrue: [encoded nextPut: $:] ifFalse: [encoded nextPut: $\; nextPut: char] ] ]	
		]

	! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:01'!
go

	s entries do: [:e|
		e isDirectory
			ifTrue: [ self goDirectory: e ]
			ifFalse: [ self goFile: e  ] 
		 ].
	^self stream contents! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:56'!
goDirectory: e 

	self streamMakeDir: e.
	(self subDir: e name)
		stream: self stream;
		go! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:18'!
goFile: e

	self stream 
		nextPutAll: 'cp -p '; 
		nextPutAll: (self encodeMacFileName: s fullName);
		nextPutAll: FileDirectory slash;
		nextPutAll: (self encodeMacFileName:e name);
		space;
		nextPutAll: (self encodeMacFileName: d fullName);
		nextPutAll: ';';
		cr! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:18'!
s: fd1 d: fd2

	s := fd1.
	d := fd2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 05:02'!
sp: s1 dp: s2

	s := FileDirectory on: s1.
	d := FileDirectory on: s2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 13:38'!
stream

	stream isNil ifTrue: 
		[stream := WriteStream on: ByteString new].
	^stream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:17'!
stream: aWriteStream

	stream := aWriteStream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 11:28'!
streamMakeDir: e
	
	{ 'mkdir '. self encodeMacFileName: (d fullName, FileDirectory slash, e name). ';' }
		do: [:part| self stream nextPutAll: part].
		
	self stream cr
! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:19'!
subDir: aString

	^self class new
		s: (s directoryNamed: aString)
		d: (d directoryNamed: aString)! !
